unit formPTChart;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Data.DB,
  VCLTee.TeEngine, VCLTee.TeeURL, VCLTee.TeeSeriesTextEd, VCLTee.Series,
  Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart, VCLTee.DBChart, VCLTee.TeeTools, commasplit,
  Vcl.StdCtrls, Vcl.buttons;

type
  TfrmPTChart = class(TForm)
    DBChart1: TDBChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    SeriesTextSource1: TSeriesTextSource;
    SeriesTextSource2: TSeriesTextSource;
    Series3: TLineSeries;
    SeriesTextSource3: TSeriesTextSource;
    Series4: TLineSeries;
    SeriesTextSource4: TSeriesTextSource;
    Button1: TSpeedButton;

    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBChart1GetAxisLabel(Sender: TChartAxis; Series: TChartSeries;
      ValueIndex: Integer; var LabelText: string);
  private
    procedure ReadToArrays;
    function Elev(aMD: double): double;
    procedure DrawRightAxis;
    procedure DrawLeftAxis;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPTChart: TfrmPTChart;
  MD: array of double;
  VD: array of double;
  EL: array of double;

implementation

{$R *.dfm}

procedure TfrmPTChart.Button1Click(Sender: TObject);
var
  s: string;
  d: double;

begin
  if Button1.Down then
    DrawLeftAxis
  else
  begin
    DBChart1.Axes.Left.Items.Clear;
    DrawRightAxis;
  end;
end;

procedure TfrmPTChart.DBChart1GetAxisLabel(Sender: TChartAxis;
  Series: TChartSeries; ValueIndex: Integer; var LabelText: string);
var
  tmp: Double;

begin
//  if Sender = DBChart1.Axes.Right then
//  begin
//   tmp:=StrToFloatDef(LabelText, 0);
//    // transform tmp value here
//    LabelText:=FormatFloat(Sender.AxisValuesFormat, tmp);
//  end;
end;

procedure TfrmPTChart.FormShow(Sender: TObject);
var
  i: integer;
  LStrList: TStringList;
  Lcs: TCommaSplitter;

begin
// Pressure vs Depth
  with SeriesTextSource1 do
  begin
    FileName := 'C:\Code_Test_Progs\DeviatedPT\DeviatedPT.txt';
    FieldSeparator:=',';
    Fields.Clear;
    AddField('X',3);
    AddField('Y',1);
    Load;
  end;
  Series1.DataSource := SeriesTextSource1;

// WHP vs Depth
  with SeriesTextSource2 do
  begin
    FileName := 'C:\Code_Test_Progs\DeviatedPT\DeviatedPT.txt';
    FieldSeparator:=',';
    Fields.Clear;
    AddField('X',4);
    AddField('Y',1);
    Load;
  end;
  Series2.DataSource := SeriesTextSource2;

// Temperature vs Depth
  with SeriesTextSource3 do
  begin
    FileName := 'C:\Code_Test_Progs\DeviatedPT\DeviatedPT.txt';
    FieldSeparator:=',';
    Fields.Clear;
    AddField('X',2);
    AddField('Y',1);
    Load;
  end;
  Series3.DataSource := SeriesTextSource3;

  ReadToArrays;
  DrawRightAxis;

end;

procedure TfrmPTChart.ReadToArrays;
var
  Lsl: TStringList;
  i: integer;
  s: string;

begin
  Lsl := TStringList.Create;
  try
    Lsl.LoadFromFile('C:\Code_Test_Progs\DeviatedPT\AT-203_Deviation.csv');

    SetLength(MD,Lsl.Count);
    SetLength(VD,Lsl.Count);
    SetLength(EL,Lsl.Count);

    for i := 1 to Lsl.Count -1 do
    begin
      s := Lsl[i];
      begin
        MD[i-1] := StrToFloat(Copy(s,1,Pos(',',s)-1));
        s := Copy(s,Pos(',',s) + 1,Length(s));
        VD[i-1] := StrToFloat(Copy(s,1,Pos(',',s)-1));
        EL[i-1] := StrToFloat(Copy(s,Pos(',',s) + 1,Length(s)));
      end;
    end;
  finally
    Lsl.Free;
  end;
end;

function TfrmPTChart.Elev(aMD: double): double;
var
  i,j: Integer;

begin
  if aMD < MD[0] then
    j := 0
  else
  if aMD > MD[Length(MD)-2] then
    j := Length(MD) - 3
  else
  for i := 0 to Length(MD) - 2 do
  begin
    if aMD < MD[i] then
    begin
      j := i - 1;
      break;
    end;
  end;

  result := (aMD - MD[j])/(MD[j+1] - MD[j])*(EL[j+1]-EL[j]) + EL[j];

end;

procedure TfrmPTChart.DrawRightAxis;
var
  i: integer;

begin
 with DBChart1.Axes.Right do
  begin
    Items.Clear;
    i:=Round(Minimum);
    repeat
      Items.Add(i, FloatToStr(Round(Elev(i)*10)/10));  // adding custom label
      Inc(i, 100);
    until i>=Round(Maximum);
  end;
end;

procedure TfrmPTChart.DrawLeftAxis;
var
  i: integer;

begin
 with DBChart1.Axes.Left do
  begin
    Items.Clear;
    i:=Round(Minimum);
    repeat
      Items.Add(i, FloatToStr(Round(Elev(i)*10)/10));  // adding custom label
      Inc(i, 100);
    until i>=Round(Maximum);
  end;
end;

end.
